;
; DZMAIN.INC
;
; This file is part of DOSZIP
; Copyright (c) 1996 Hjort Nidudsson.
;

INCLUDE		wsub.inc

IFDEF DEBUG
; _DOSBMP_	=	1
ENDIF

MAXFBLOCK	= 	2000
MAXDOSKEYLINES	= 	10
MAXCOMMANDLINE	= 	128

_C_PANELID	= 	0001h
_C_HORIZONTAL	= 	0002h
_C_SMALLPANELS	= 	0004h
_C_EGALINE	= 	0008h
_C_SELECTDIR	= 	0010h
_C_INSMOVDN	= 	0020h
_C_CDCLRDONLY	= 	0040h
_C_AUTOSAVE	=	0080h
_C_DELBATCH	=	0400h

CLP_CLEARW	= 	0
CLP_MOVEUP	= 	1
CLP_MOVEDN	= 	2
CLP_DONOTHING	= 	3

PN_XYCONFIG	= 	7
PN_XYMINISTATUS	= 	6
PN_XYNEWDISK	= 	5
PN_XYMOVEUP	= 	4
PN_XYMOVEDOWN	= 	3
PN_XYFILE	= 	2
PN_XYINSIDE	= 	1
PN_XYOUTSIDE	= 	0

;;--------------------------------------------------------------------------

XCELLS		STRUC
		xl_flag		DW ?
		xl_cols		DB ?
		xl_rows		DB ?
		xl_rect		DD ?
		xl_bp		DD ?
		xl_cpos		DD ?
		ENDS

PANELS		STRUC
		pn_flag		DD ?
		pn_fcb_count	DW ?
		pn_fcb_index	DW ?
		pn_cel_count	DW ?
		pn_cel_index	DW ?
		pn_xl		DD ?
		pn_dialog	DD ?
		pn_wsub		DD ?
		pn_putfcb	PF ?
		ENDS

FILTS		STRUC
		of_flag		DW ?
		of_max_date	DW ?
		of_min_date	DW ?
		of_max_size	DD ?
		of_min_size	DD ?
		of_include	DB 128 dup(?)
		of_exclude	DB 128 dup(?)
		ENDS

CONFIGS		STRUC
		c_version	DW ?
		c_lflag		DW ?
		c_confirm	DB ?
		c_console	DB ?
		c_tvflag	DB ?
		c_fsflag	DB ?
		c_compress	DW ?
		c_pbindex	DW 2 dup(?)
		c_pcindex	DW 2 dup(?)
		c_apath		W_PATH ?
		c_bpath		W_PATH ?
		c_filter	FILTS ?
		c_color		DB 40 dup(?)
		c_pending_file	DB WMAXPATH dup(?)
		ENDS

CMDLS		STRUC
		cmdl_base	DB WMAXPATH dup(?)
		cmdl_bp		DD ?
		cmdl_count	DW ?
		cmdl_rc		DD ?
		cmdl_sub	DD ?
		ENDS

EXECS		STRUC
		exec_name	DB 80 dup(?)
		exec_argc	DB ?
		exec_argv	DB ?
		exec_command	DB 126 dup(?)
		ENDS

EXES		STRUC
		exe_signature		DW ?
		exe_last512		DW ?
		exe_total512		DW ?
		exe_relocation_entries	DW ?
		exe_header_size		DW ?
		exe_minimum_memory	DW ?
		exe_maximum_memory	DW ?
		exe_initial_SS		DW ?
		exe_initial_SP		DW ?
		exe_checksum		DW ?
		exe_initial_CSIP	DD ?
		exe_offset_relocation	DW ?
		exe_overlay		DW ?
		ENDS

;;--------------------------------------------------------------------------

GLOBAL cp_section_view:	BYTE

GLOBAL numfblock: 	WORD
GLOBAL argv_verbose: 	WORD
GLOBAL argv_cfgpath: 	DWORD
GLOBAL argv_filename: 	DWORD

GLOBAL dzexe:		DWORD
GLOBAL dzerrno: 	WORD
GLOBAL dzerflag: 	WORD
GLOBAL dzcount: 	WORD
GLOBAL _end: 		WORD
GLOBAL dzexitcode:	WORD

GLOBAL comspec:		DWORD
GLOBAL envpath: 	DWORD
GLOBAL envtemp: 	DWORD
GLOBAL envconf: 	DWORD

GLOBAL config:		CONFIGS
GLOBAL cpanel: 		DWORD
GLOBAL spanel: 		DWORD
GLOBAL spanelb: 	DWORD
GLOBAL wspanel: 	WORD
GLOBAL wspanelb: 	WORD
GLOBAL com: 		BYTE:[SIZE CMDLS]
GLOBAL ex_block: 	BYTE:[SIZE EXECS]
GLOBAL programpath: 	BYTE:[MAXPATH]
GLOBAL __outpath:	BYTE:[WMAXPATH]
GLOBAL __srcpath:	BYTE:[WMAXPATH]
GLOBAL __outfile:	BYTE:[WMAXPATH]
GLOBAL __srcfile:	BYTE:[WMAXPATH]

GLOBAL paneldlgA: 	WORD
GLOBAL paneldlgB: 	WORD
GLOBAL panelcelA: 	WORD
GLOBAL panelcelB: 	WORD
GLOBAL cp_statusline: 	BYTE
GLOBAL cp_menusline:	BYTE

GLOBAL dl_progress:	WORD

GLOBAL PASCAL panel_state:	DIST
GLOBAL PASCAL panel_read:	DIST
GLOBAL PASCAL panel_setid:	DIST
GLOBAL PASCAL panel_curobj:	DIST
GLOBAL PASCAL panel_hndevent: 	DIST
GLOBAL PASCAL panel_putitem: 	DIST
GLOBAL PASCAL panel_putinfo:	DIST
GLOBAL PASCAL panel_update_all:	DIST
GLOBAL PASCAL panel_update_rect:DIST
GLOBAL PASCAL putmini_selected:	DIST

GLOBAL PASCAL prect_open:	DIST
GLOBAL PASCAL prect_close: 	DIST

GLOBAL PASCAL pcell_set:	DIST
GLOBAL PASCAL pcell_show:	DIST
GLOBAL PASCAL pcell_select:	DIST
GLOBAL PASCAL pcell_update: 	DIST
GLOBAL PASCAL xl_getrect:	DIST

GLOBAL PASCAL load_tview: 	DIST
GLOBAL PASCAL load_tedit: 	DIST
GLOBAL PASCAL FindFile:		DIST

GLOBAL PASCAL ex_command:	DIST
GLOBAL PASCAL com_setdevice:	DIST

GLOBAL PASCAL scpush: 		DIST
GLOBAL PASCAL scpop: 		DIST
GLOBAL PASCAL trace: 		DIST
GLOBAL PASCAL qwtobstr:		DIST
GLOBAL PASCAL _disk_init:	DIST

;;--------------------------------------------------------------------------

		.386p

		LOCALS

;;--------------------------------------------------------------------------
